Subject: bug#5060: More debugging information

From: Michael Welsh Duggan <[email-masked]>
Date: Sun, 29 Nov 2009 22:59:02 -0500

[email-masked] (Nick Roberts) writes:

>  > Shortly before the failure occurs, gdb-frame-handler is called.  In the
>  > context of the failure, the frame variable is set to:
>  > 
>  >   ((line . "29") (file . "longjmp.c") (func . "__libc_siglongjmp") 
>  >    (addr . "0xb79ef6c1") (level . "0"))
>  > 
>  > gdb-selected-file is nil, since there is no 'fullname.
>  > gdb-selected-line gets 29.  So, gud-last-frame is '(nil . 29).
>  > gud-display-frame is then called, which calls gud-display-line with the
>  > args from gud-last frame.  I.e., (gud-display-frame nil 29).  This nil
>  > is what is later causing problems when gud-find-file is called.
>  > 
>  > My guess is that gud-display-frame should not be called if
>  > gdb-selected-file is nil.  But I do not understand the code well enough
>  > to know that this is the case.
>
> That sounds right.  Using gdb-frame-handler to get the current line is
> a bit of a hack because gdb doesn't always print the location when it
> stops.  This code doesn't look quite right.  Does the patch below
> work?

It does work.  I will be submitting a followup misfeature as a separate
bug.

-- 
Michael Welsh Duggan
([email-masked])